;-------------------------------------------------
;Z80 DISASSEMBLER LISTING
;Label  Instruction
;-------------------------------------------------
;4 mhz clock,1834 uart clock,  8k rom, 8k ram
;PORT 00: data, port 01 control/status
;4 input,  5 and 6 output


       TXD EQU 00106H
       RXD EQU 0011CH

.org 2000H

LOOP:  	CALL RXD
	CP 'M'
	CALL Z, MUSTAFA
	CP 1BH
	JP Z, 0045H
	PUSH AF
       CALL TXD
       LD A, ':'
	CALL TXD
	POP AF
       CALL HEXOUT
	LD A, 0AH
	CALL TXD
	LD A, 0DH
	CALL TXD
	JP LOOP
	
	
;HEXOUT DO NOT CHANGES ANY REGISTER	
HEXOUT:	PUSH BC ; THIS SUBROUTINE SENDS CONTENTS OF ACC TO TERMINAL AS 
	PUSH DE ; TWO CHAR HEX VALUE (ASCII) 
	PUSH HL
	PUSH AF
	
	AND 0F0H
	RRA
	RRA
	RRA
	RRA
	LD (3F33H),A  ;HIGH NIBBLE SYSTEM VARIABLE
	CALL HEXAS
	
	POP AF
	PUSH AF
	AND 00FH
	LD (3F32H),A  ;LOW NIBBLE SYSTEM VARIABLE
	CALL HEXAS
	
	POP AF
	POP HL
	POP DE
	POP BC
	
	RET
	
HEXAS:	LD HL, TABLEX ; HEX NIBBLE TO ASCII CONVERTER
	LD  B, 0	;ADDING HL WITH A
	LD  C, A
	ADC HL, BC
       	LD A,(HL)
	CALL TXD ;TXD ROUTINE
	RET	
TABLEX:	.DB '0','1','2','3','4','5','6','7'
	.DB '8','9','A','B','C','D','E','F'	







MUSTAFA:
	
	LD HL,TABLE
	LD B, 9
DIS:	LD A,(HL)
	CALL TXD
        INC HL
	DJNZ DIS
	
	RET
	
TABLE: 	.DB ' MUSTAFA '
	
	
	
	
	

	
	.END